#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Empty Category Checker
# DIZ: Enables you to view a list of categories that contains no links.
# GRAPHIC: ic_folders.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "check_dirs") {&check_dirs;}
if ($q->param('fct') eq "del_empty") {&del_empty;}
if ($q->param('fct') eq "del_empty2") {&del_empty2;}



###############################################################
sub del_empty2
{

if ($q->param('B1') ne "") 
	{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

	$sql = "DELETE FROM dirs WHERE linknrs < 1";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
	$rows = $sth->rows();

	$sth->finish;
	$dbh->disconnect;

	$hbox = acs::get_heading_box("$web_url/ic_folders.gif", "Empty Categories Deleted", qq[
	<a href="$admin_url/p_emptydir.cgi">Click Here to Continue</a>
	]);
	
	print qq[<html>
	<head>
	<title>PowerSeek</title>
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
	</head>
	<body>
	$hbox
	</body>
	</html>
	];
	}
elsif ($q->param('B2') ne "") 
	{
	&start;
	exit;
	}


}



sub del_empty
{

$hbox = acs::get_heading_box("$web_url/ic_folders.gif", "Delete Empty Categories", qq[<form method="POST" action="$admin_url/p_emptydir.cgi">
  <input type="hidden" name="fct" value="del_empty2">
  <strong>Are you sure? <br>
  </strong>The categories you are about to delete will be lost permanently!<br>
  &nbsp; <br>
  <input type="submit" value="    Yes    " name="B1"> 
  <input type="submit" value="   No   "
  name="B2">
</form>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}


sub start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT * FROM dirs WHERE linknrs < 1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_folders.gif", "Empty Category Checker", qq[<p>This plugin will display categories that has no links inside them.
  Note that it may be a good idea to re-count category link numbers before checking empty categories. If you have a very large database with 
  hundreds of thousands of links then you will need to recount the links by executing $admin_url/recountlnks.cgi from an SSH session.
  <b>
  </b></p>
<b><ul><li>
  <p><a href="$admin_url/recountlnks.cgi?fct=count" target="_blank">Click Here to Recount Links</a></p>
</ul><ul><li><p><a href="$admin_url/p_emptydir.cgi?fct=check_dirs">View Empty Categories</a> - There are $rows empty categories.</p>
  <li>
  <p><a href="$admin_url/p_emptydir.cgi?fct=del_empty">Delete Categories that are empty</a>  - There are $rows empty categories. </p>
</ul>
</li>
</b>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}


sub check_dirs
{


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT * FROM dirs WHERE linknrs < 1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$rows = $sth->rows();



while ( @row = $sth->fetchrow() )
	{
	$ecat = ""; $rcat = "";
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$rcat = $rcat . "$row[$ms]/";
			$ecat = $ecat . acs::encode_dir($row[$ms]) . "-";
			}
		}
	chop($ecat); 
	
	$all_cats = $all_cats . qq[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[0]" target="_blank">$rcat</a><BR>];
	
	}




$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_folders.gif", "Empty Category Checker", qq[Displaying categories thas has no links:<BR><BR>
$all_cats
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<p>
<b><a href="$admin_url/p_emptydir.cgi">Go Back</a></b>
</p>
</body>
</html>
];



}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

